#include "global.h"

static Token longjmp_stack_t, unwind_t;
static Token longjmp_ctx_top;
static Token longjmp_ctx;

void init_except ()
{
	longjmp_stack_t = new_symbol ("longjmp_StaCk");
	unwind_t = new_symbol ("AuToDt_t");
	longjmp_ctx_top = new_symbol ("longjmp_StaCkTop");
	longjmp_ctx = new_symbol ("longjmp_CoNtExT");
}

void decl_except_data ()
{
	outprintf (GLOBAL,
		   RESERVED_typedef, RESERVED_struct, RESERVED_ucontext,
		   RESERVED_ucontext_t, ';', -1);

	outprintf (GVARS,
		   RESERVED_int, RESERVED_getcontext, '(', RESERVED_ucontext_t, '*', ')', ';',
	 	   RESERVED_int, RESERVED_setcontext, '(', RESERVED_const,
			 RESERVED_ucontext_t, '*', ')', ';', -1);

	outprintf (STRUCTS,
		RESERVED_struct, unwind_t, '{',
		RESERVED_struct, unwind_t, '*', RESERVED_X, ';',
		RESERVED_void, '*', RESERVED_x, ';',
		RESERVED_void, '*', '(', '*' , RESERVED_y, ')', '(', RESERVED_void, '*', ')', ';',
		'}', ';', -1);

	outprintf (STRUCTS,
		RESERVED_struct, longjmp_stack_t, '{',
		RESERVED_char, RESERVED_x, '[', new_symbol (SIZEOF_UCONTEXT), ']', ';',
		RESERVED_struct, longjmp_stack_t, '*', RESERVED_y, ';',
		RESERVED_int, RESERVED_X, ';',
		RESERVED_struct, unwind_t, '*', RESERVED_i, ';',
		'}', ';', -1);

	outprintf (GVARS, MainModule ? BLANKT : RESERVED_extern,
	   Reentrant ? RESERVED___thread : BLANKT,
	   RESERVED_struct, longjmp_stack_t, '*', longjmp_ctx_top, ';', -1);

#define EHTOP longjmp_ctx_top, POINTSAT
#define ADTOP EHTOP, RESERVED_i
	outprintf (GVARS, RESERVED_extern, RESERVED_void, RESERVED___lwc_unwind,
		   '(', RESERVED_int, ')', -1);
#ifdef	HAVE_GNUC_ATTR_NORETURN
	if (!MainModule)
		outprintf (GVARS, RESERVED___attribute__, '(', '(',RESERVED_noreturn,')', ')', -1);
#endif
	output_itoken (GVARS, ';');

	if (MainModule)
		outprintf (GVARS, RESERVED_void, RESERVED___lwc_unwind, '(', RESERVED_int,
			   RESERVED_X, ')', '{',
			   EHTOP, RESERVED_X, '=', RESERVED_X, ';',
			   RESERVED_while, '(', ADTOP, ')', '{',
			   ADTOP, POINTSAT, RESERVED_y, '(', ADTOP, POINTSAT, RESERVED_x, ')', ';',
			   ADTOP, '=', ADTOP, POINTSAT, RESERVED_X, ';', '}',
			   RESERVED_setcontext, '(', '(', RESERVED_ucontext_t, '*',
			   ')', EHTOP, RESERVED_x, ')', ';', '}', -1);
}


void push_unwind (OUTSTREAM o, recID r, Token arg)
{
#define NOWARNONTYPE '(', RESERVED___typeof__, '(', u, '.', RESERVED_y, ')', ')'
	Token u = internal_identifier1 ();
	outprintf (o, RESERVED_struct, unwind_t, u, '=', '{',
		   '.', RESERVED_X, '=', ADTOP, ',',
		   '.', RESERVED_x, '=', '&', arg, ',',
		   '.', RESERVED_y, '=', NOWARNONTYPE, dtor_name (r), ',',
		   '}', ';', ADTOP, '=', '&', u, ';', -1);
}

void pop_unwind (OUTSTREAM o)
{
	outprintf (o, ADTOP, '=', ADTOP, POINTSAT, RESERVED_X, ';', -1);
}

NormPtr throw_statement (OUTSTREAM o, NormPtr p)
{
	outprintf (o, RESERVED___lwc_unwind, '(', -1);

	if (CODE [p] == ';')
		output_itoken (o, RESERVED_1);
	else { 
		exprret E;
		p = parse_expression_retconv (p, &E, typeID_int, NORMAL_EXPR);
		if (!E.ok) return p + 1;
		outprintf (o, ISTR (E.newExpr), -1);

		free (E.newExpr);
		if (CODE [p] != ';')
			parse_error (p, "excepted ';' after throw expression");
	}

	outprintf (o, ')', ';', -1);

	return p + 1;
}

NormPtr try_statement (OUTSTREAM o, NormPtr p)
{
	Token x = RESERVED_x;
	Token y = RESERVED_y;
	Token X = RESERVED_X;
	Token retcode;
	bool have_retcode;

	if (have_retcode = CODE [p] == '(') {
		open_local_scope ();
		if (!issymbol (retcode = CODE [++p]))
			parse_error (p, "try ( 'identifier' )");
		if (CODE [++p] != ')')
			parse_error (p, "try (identifier ')'");
		++p;
		enter_local_obj (retcode, typeID_int);
	} else retcode = internal_identifier1 ();

	outprintf (o, '{', RESERVED_struct, longjmp_stack_t, longjmp_ctx, ';',
		   longjmp_ctx, '.', y, '=', longjmp_ctx_top, ';', longjmp_ctx_top,
		   '=', '&', longjmp_ctx, ';', longjmp_ctx, '.', X, '=', RESERVED_0, ';',
		   longjmp_ctx, '.', RESERVED_i, '=', RESERVED_0, ';',
		   RESERVED_getcontext, '(', '(', RESERVED_ucontext_t, '*', ')', longjmp_ctx,
		   '.', x, ')', ';', RESERVED_int, retcode, '=', longjmp_ctx, '.', X, ';',
		   RESERVED_if, '(', '!', retcode, ')', '{', -1);

	p = statement (o, p);
	outprintf (o, longjmp_ctx_top, '=', longjmp_ctx, '.', y, ';', '}', -1);

	if (CODE [p] == RESERVED_else) {
		outprintf (o, RESERVED_else, '{', 
			   longjmp_ctx_top, '=', longjmp_ctx, '.', y, ';', -1);

		p = statement (o, p + 1);

		outprintf (o, '}', -1);
	}

	outprintf (o, '}', -1);
	if (have_retcode) close_local_scope ();

	return p;
}
